'----------------------------------------------------------------------------------------
' patterns & practices - Smart Client Software Factory - Guidance Package
'
' This file was generated by this guidance package as part of the solution template
'
' The ControlledWorkItem represents a WorkItem that is managed by another class. 
' The other class is the controller and contains the business logic 
' (the WorkItem provides the container.)
'
' For more information see: 
' ms-help://MS.VSCC.v90/MS.VSIPCC.v90/ms.practices.scsf.2008apr/SCSF/html/03-01-010-How_to_Create_Smart_Client_Solutions.htm
'
' Latest version of this Guidance Package: http://go.microsoft.com/fwlink/?LinkId=62182
'----------------------------------------------------------------------------------------

Imports Microsoft.Practices.CompositeUI

''' <summary>
''' Represents a WorkItem that uses a WorkItem controller to perform its business logic.
''' </summary>
''' <typeparam name="TController"></typeparam>
Public NotInheritable Class ControlledWorkItem(Of TController)
    Inherits WorkItem

    Private _controller As TController

    ''' <summary>
    ''' Gets the controller.
    ''' </summary>
    Public ReadOnly Property Controller() As TController
        Get
            Return _controller
        End Get
    End Property

    ''' <summary>
    ''' See <see cref="M:Microsoft.Practices.ObjectBuilder.IBuilderAware.OnBuiltUp(System.String)"/> for more information.
    ''' </summary>
    Public Overrides Sub OnBuiltUp(ByVal id As String)
        MyBase.OnBuiltUp(id)

        _controller = Items.AddNew(Of TController)()
    End Sub
End Class