'----------------------------------------------------------------------------------------
' patterns & practices - Smart Client Software Factory - Guidance Package
'
' The EntityTranslatorService class is a service that provides a registry of
' translators and translation services between two classes. The user must implement
' the translators and register them with the service.
'
' For more information see: 
' ms-help://MS.VSCC.v90/MS.VSIPCC.v90/ms.practices.scsf.2008apr/SCSF/html/03-01-010-How_to_Create_Smart_Client_Solutions.htm
'
' Latest version of this Guidance Package: http://go.microsoft.com/fwlink/?LinkId=62182
'----------------------------------------------------------------------------------------

Imports System

Namespace Services
    Public Interface IEntityTranslatorService

        Function CanTranslate(ByVal targetType As Type, ByVal sourceType As Type) As Boolean
        Function CanTranslate(Of TTarget, TSource)() As Boolean
        Function Translate(ByVal targetType As Type, ByVal source As Object) As Object
        Function Translate(Of TTarget)(ByVal source As Object) As TTarget
        Sub RegisterEntityTranslator(ByVal translator As IEntityTranslator)
        Sub RemoveEntityTranslator(ByVal translator As IEntityTranslator)
    End Interface

End Namespace