'----------------------------------------------------------------------------------------
'patterns & practices - Smart Client Software Factory - Guidance Package
'
'This file was generated by this guidance package as part of the solution template
'
'The EventTopicExceptionFormatter class is an Enterprise Library TextExceptionFormatter
'that will format an EventTopicException in a clear way
' 
'For more information see: 
'ms-help://MS.VSCC.v90/MS.VSIPCC.v90/ms.practices.scsf.2008apr/SCSF/html/03-01-010-How_to_Create_Smart_Client_Solutions.htm
'
'Latest version of this Guidance Package: http://go.microsoft.com/fwlink/?LinkId=62182
'----------------------------------------------------------------------------------------

Imports System
Imports System.IO
Imports Microsoft.Practices.CompositeUI.EventBroker
Imports Microsoft.Practices.EnterpriseLibrary.ExceptionHandling

Public Class EventTopicExceptionFormatter
    Inherits TextExceptionFormatter

    Public Sub New(ByVal writer As TextWriter, ByVal exception As Exception)
        MyBase.New(writer, exception)
    End Sub

    Protected Overrides Sub WriteException(ByVal exceptionToFormat As System.Exception, ByVal outerException As System.Exception)
        Dim ete As EventTopicException = TryCast(exceptionToFormat, EventTopicException)

        If Not ete Is Nothing Then
            For Each ex As Exception In ete.Exceptions
                MyBase.WriteException(ex, Nothing)
            Next
        End If

        MyBase.WriteException(exceptionToFormat, outerException)
    End Sub

End Class
