'----------------------------------------------------------------------------------------
'patterns & practices - Smart Client Software Factory - Guidance Package
'
'This file was generated by this guidance package as part of the solution template
'
'The ModuleMetadataReflectionHelper class provides a helper to retrieve module relevant information
'like dependencies and the name of the module from a given assembly
' 
'For more information see: 
'ms-help://MS.VSCC.v90/MS.VSIPCC.v90/ms.practices.scsf.2008apr/SCSF/html/03-01-010-How_to_Create_Smart_Client_Solutions.htm
'
'Latest version of this Guidance Package: http://go.microsoft.com/fwlink/?LinkId=62182
'---------------------------------------------------------------------------------------

Imports System.Reflection
Imports Microsoft.Practices.CompositeUI
Imports System.Collections.Generic
Imports System.IO

Namespace Services

    Public Class ModuleMetadataReflectionHelper

        Public Shared Function GetModuleName(ByVal assemblyFilename As String) As String
            Try
				Dim assemblyFullPath As String
				assemblyFullPath = Path.GetFullPath(assemblyFilename)
                Return GetModuleName(Assembly.LoadFile(assemblyFullPath))
            Catch
                Return Nothing
            End Try
        End Function

        Public Shared Function GetModuleName(ByVal assm As Assembly) As String
            Dim attrib As ModuleAttribute
            For Each attrib In assm.GetCustomAttributes(GetType(ModuleAttribute), False)
                Return attrib.Name
            Next

            Return Nothing
        End Function

        Public Shared Function GetModuleDependencies(ByVal assemblyFileName As String) As IList(Of String)
            Try
                Return GetModuleDependencies(Assembly.LoadFile(assemblyFileName))
            Catch
                Return New List(Of String)
            End Try

        End Function

        Public Shared Function GetModuleDependencies(ByVal asm As Assembly) As IList(Of String)

            Dim results As New List(Of String)

            For Each attrib As ModuleDependencyAttribute In asm.GetCustomAttributes(GetType(ModuleDependencyAttribute), False)
                results.Add(attrib.Name)
            Next

            Return results
        End Function

    End Class
End Namespace