'----------------------------------------------------------------------------------------
'patterns & practices - Smart Client Software Factory - Guidance Package
'
'This file was generated by this guidance package as part of the solution template
'
'The ProfileCatalogModuleInfoStore class provides the default implementation
'for IModuleInfoStore. It retrieves the profile catalog from a local file.
' 
'For more information see: 
'ms-help://MS.VSCC.v90/MS.VSIPCC.v90/ms.practices.scsf.2008apr/SCSF/html/03-01-010-How_to_Create_Smart_Client_Solutions.htm
'
'Latest version of this Guidance Package: http://go.microsoft.com/fwlink/?LinkId=62182
'----------------------------------------------------------------------------------------

Imports System.IO
Imports Microsoft.Practices.CompositeUI.Utility

Namespace Services

    Public Class ProfileCatalogModuleInfoStore
        Implements IModuleInfoStore

        Private _catalogFilePath As String

        Public Sub New()
            _catalogFilePath = "ProfileCatalog.xml"
        End Sub

        Public Property CatalogFilePath() As String
            Get
                Return _catalogFilePath
            End Get
            Set(ByVal Value As String)
                Guard.ArgumentNotNullOrEmptyString(value, "Catalog File Path")

                _catalogFilePath = value
            End Set
        End Property

        Public Function GetModuleListXml() As String Implements IModuleInfoStore.GetModuleListXml
            Dim result As String

            Try
                result = File.ReadAllText(_catalogFilePath)
            Catch
                result = Nothing
            End Try

            Return result
        End Function
    End Class

End Namespace

