'----------------------------------------------------------------------------------------
'patterns & practices - Smart Client Software Factory - Guidance Package
'
'This file was generated by this guidance package as part of the solution template
'
'The WebServiceCatalogModuleInfoStore class provides an implementation of IModuleInfoStore
'that will retrieve the profile catalog from a webservice. It depends on the IProfileCatalogService
'to work. Using this IModuleInfoStore is possible to retrieve a profile catalog from a central location
' 
'For more information see: 
'ms-help://MS.VSCC.v90/MS.VSIPCC.v90/ms.practices.scsf.2008apr/SCSF/html/03-01-010-How_to_Create_Smart_Client_Solutions.htm
'
'Latest version of this Guidance Package: http://go.microsoft.com/fwlink/?LinkId=62182
'----------------------------------------------------------------------------------------

Imports Microsoft.Practices.CompositeUI
imports Microsoft.Practices.CompositeUI.Utility
imports Microsoft.Practices.ObjectBuilder
Imports SmartClientDevelopmentSolution1.Infrastructure.Library.Services

Namespace Services

    Public Class WebServiceCatalogModuleInfoStore
        Implements IModuleInfoStore

        Private _catalogUrl As String
        Private _roles As String()
        Private _catalogService As IProfileCatalogService

        <InjectionConstructor()> _
        Sub New(<ServiceDependency()> ByVal catalogService As IProfileCatalogService)
            _catalogService = catalogService
            _catalogUrl = "http://localhost:54092/profilecatalogservices/profilecatalog.asmx"
        End Sub

        Public Property CatalogUrl() As String
            Get
                Return _catalogUrl
            End Get
            Set(ByVal Value As String)
                Guard.ArgumentNotNullOrEmptyString(value, "Catalog Url")

                _catalogUrl = value
            End Set
        End Property

        Public Property Roles() As String()
            Get
                Return _roles
            End Get
            Set(ByVal Value As String())
                Guard.ArgumentNotNull(value, "Roles")

                _roles = value
            End Set
        End Property

        Public Function GetModuleListXml() As String Implements IModuleInfoStore.GetModuleListXml
            Try
                _catalogService.Url = _catalogUrl
                Return _catalogService.GetProfileCatalog(_roles)

            Catch
                Return Nothing
            End Try
        End Function
    End Class
End Namespace