'----------------------------------------------------------------------------------------
'patterns & practices - Smart Client Software Factory - Guidance Package
'
'This file was generated by this guidance package as part of the solution template
'
'The XmlStreamDependentModuleEnumerator class provides an implementation of IModuleEnumerator
'that is used to retrieve an array of IModuleInfo. This service depends on the IModuleInfoStore service
'that provides the storage of the profile catalog
' 
'For more information see: 
'ms-help://MS.VSCC.v90/MS.VSIPCC.v90/ms.practices.scsf.2008apr/SCSF/html/03-01-010-How_to_Create_Smart_Client_Solutions.htm
'
'Latest version of this Guidance Package: http://go.microsoft.com/fwlink/?LinkId=62182
'----------------------------------------------------------------------------------------

Imports System
Imports System.Xml
Imports SmartClientDevelopmentSolution1.Infrastructure.Library.Services
Imports Microsoft.Practices.CompositeUI
Imports Microsoft.Practices.CompositeUI.Configuration
Imports Microsoft.Practices.CompositeUI.Services

Public Class XmlStreamDependentModuleEnumerator
    Implements IModuleEnumerator

    Private _moduleInfoStore As IModuleInfoStore

    Public Sub New()

    End Sub

    <ServiceDependency()> _
    Public Property ModuleInfoStore() As IModuleInfoStore
        Get
            Return _moduleInfoStore
        End Get
        Set(ByVal value As IModuleInfoStore)
            _moduleInfoStore = value
        End Set
    End Property

    Public Function EnumerateModules() As Microsoft.Practices.CompositeUI.Configuration.IModuleInfo() Implements Microsoft.Practices.CompositeUI.Services.IModuleEnumerator.EnumerateModules
        Dim xml As String = _moduleInfoStore.GetModuleListXml()

        If String.IsNullOrEmpty(xml) Then
            Return New DependentModuleInfo(0) {}
        End If

        Dim doc As XmlDocument = New XmlDocument()
        doc.LoadXml(xml)

        Select Case doc.FirstChild.NamespaceURI

            Case SolutionProfileV1Parser._Namespace
                Return New SolutionProfileV1Parser().Parse(xml)

            Case SolutionProfileV2Parser._Namespace
                Return New SolutionProfileV2Parser().Parse(xml)

            Case Else
                Throw New InvalidOperationException(My.Resources.InvalidSolutionProfileSchema)
        End Select
    End Function
End Class
