'----------------------------------------------------------------------------------------
'patterns & practices - Smart Client Software Factory - Guidance Package
'
'This file was generated by this guidance package as part of the solution template
'
'The XmlValidationHelper class is a helper used internally to work with xml serialization and validation
' 
'For more information see: 
'ms-help://MS.VSCC.v90/MS.VSIPCC.v90/ms.practices.scsf.2008apr/SCSF/html/03-01-010-How_to_Create_Smart_Client_Solutions.htm
'
'Latest version of this Guidance Package: http://go.microsoft.com/fwlink/?LinkId=62182
'----------------------------------------------------------------------------------------

Imports System
Imports System.Collections.Generic
Imports System.Text
Imports System.Xml
Imports System.IO
Imports System.Xml.Serialization
Imports System.Reflection

Public Class XmlValidationHelper

    Public Shared Function DeserializeXML(Of TRootElement)(ByVal xml As String, ByVal xsdResourceName As String, ByVal schemaUri As String) As TRootElement
        Dim serializer As New XmlSerializer(GetType(TRootElement))

        Dim reader As XmlReader = GetValidatingReader(xml, xsdResourceName, schemaUri)

        Dim rootElement As TRootElement = CType(serializer.Deserialize(reader), TRootElement)

        reader.Close()

        Return rootElement

    End Function

    Public Shared Function GetValidatingReader(ByVal xml As String, ByVal xsdResourceName As String, ByVal schemaUri As String) As XmlReader
        Dim stream As Stream = Assembly.GetExecutingAssembly().GetManifestResourceStream(String.Format("{1}.{0}", xsdResourceName, GetType(XmlValidationHelper).Namespace))
        Dim schemaReader As XmlTextReader = New XmlTextReader(stream)
        stream.Dispose()

        Dim settings As XmlReaderSettings = New XmlReaderSettings()
        settings.Schemas.Add(schemaUri, schemaReader)
        Dim xmlStringReader As StringReader = New StringReader(xml)
        Dim catalogReader As XmlReader = XmlReader.Create(xmlStringReader, settings)

        Return catalogReader
    End Function
End Class
