'----------------------------------------------------------------------------------------
'patterns & practices - Smart Client Software Factory - Guidance Package
'
'This file was generated by this guidance package as part of the solution template
'
'The FormShell class represent the main form of your application.
' 
'The default Form supplied in this guidance package provides basic UI elements 
'like:
'      - A MenuStrip
'      - A ToolStrip
'      - A StatusStrip
'      - 2 WorkSpaces (left and right) separated by a spliter
'
'There is also a subscription to the "StatusUpdate" event topic used to change the
'content of the StatusStrip
'
'For more information see: 
'ms-help://MS.VSCC.v90/MS.VSIPCC.v90/ms.practices.scsf.2008apr/SCSF/html/03-01-010-How_to_Create_Smart_Client_Solutions.htm
'
'Latest version of this Guidance Package: http://go.microsoft.com/fwlink/?LinkId=62182
'----------------------------------------------------------------------------------------

Imports System
Imports System.Windows.Forms
Imports SmartClientDevelopmentSolution1.Infrastructure.Interface
Imports SmartClientDevelopmentSolution1.Infrastructure.Shell.Constants
Imports Microsoft.Practices.CompositeUI.EventBroker

''' <summary>
''' Main application shell view.
''' </summary>
Partial Public Class ShellForm
    Inherits Form

    ''' <summary>
    ''' Default class initializer.
    ''' </summary>
    Public Sub New()
        InitializeComponent()
        _leftWorkspace.Name = WorkspaceNames.LeftWorkspace
        _rightWorkspace.Name = WorkspaceNames.RightWorkspace
    End Sub

    ''' <summary>
    ''' Gets a reference for the application statusbar (<see cref="StatusStrip"/>) object.
    ''' </summary>
    Friend ReadOnly Property MainStatusStrip() As StatusStrip
        Get
            Return _mainStatusStrip
        End Get
    End Property

    ''' <summary>
    ''' Gets a reference for the default application toolbar (<see cref="ToolStrip"/>) object.
    ''' </summary>
    Friend ReadOnly Property MainToolbarStrip() As ToolStrip
        Get
            Return _mainToolStrip
        End Get
    End Property

            ''' <summary>
            ''' Status update handler. Updates the status strip on the main form.
            ''' </summary>
            ''' <param name="sender">The sender.</param>
            ''' <param name="e">The e.</param>
    <EventSubscription(EventTopicNames.StatusUpdate, ThreadOption.UserInterface)> _
    Public Sub StatusUpdateHandler(ByVal sender As Object, ByVal e As EventArgs(Of String))
        _statusLabel.Text = e.Data
    End Sub

    ''' <summary>
    ''' Close the application.
    ''' </summary>
    Private Sub OnFileExit(ByVal sender As Object, ByVal e As EventArgs) Handles exitToolStripMenuItem.Click

            Close()
    End Sub
End Class
